Index: pjproject/main/pjlib/include/pj++/os.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/os.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/os.hpp	(revision 36)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJPP_OS_H__
@@ -9,5 +8,94 @@
 #include <pj++/pool.hpp>
 
-class PJ_Thread
+class Pj_Thread;
+
+//
+// Thread API.
+//
+class Pj_Thread_API
+{
+public:
+    //
+    // Create a thread.
+    //
+    static pj_status_t create( Pj_Pool *pool, pj_thread_t **thread,
+                               pj_thread_proc *proc, void *arg,
+                               unsigned flags = 0,
+                               const char *name = NULL,
+                               pj_size_t stack_size = 0 )
+    {
+        return pj_thread_create(pool->pool_(), name, proc, arg, stack_size,
+                                flags, thread);
+    }
+
+    //
+    // Register a thread.
+    //
+    static pj_status_t register_this_thread( pj_thread_desc desc,
+                                             pj_thread_t **thread,
+                                             const char *name = NULL )
+    {
+        return pj_thread_register( name, desc, thread );
+    }
+
+    //
+    // Get current thread.
+    // Will return pj_thread_t (sorry folks, not Pj_Thread).
+    //
+    static pj_thread_t *this_thread()
+    {
+        return pj_thread_this();
+    }
+
+    //
+    // Get thread name.
+    //
+    static const char *get_name(pj_thread_t *thread)
+    {
+        return pj_thread_get_name(thread);
+    }
+
+    //
+    // Resume thread.
+    //
+    static pj_status_t resume(pj_thread_t *thread)
+    {
+        return pj_thread_resume(thread);
+    }
+
+    //
+    // Sleep.
+    //
+    static pj_status_t sleep(unsigned msec)
+    {
+	return pj_thread_sleep(msec);
+    }
+
+    //
+    // Join the specified thread.
+    //
+    static pj_status_t join(pj_thread_t *thread)
+    {
+        return pj_thread_join(thread);
+    }
+
+    //
+    // Destroy thread
+    //
+    static pj_status_t destroy(pj_thread_t *thread)
+    {
+        return pj_thread_destroy(thread);
+    }
+};
+
+
+
+//
+// Thread object.
+//
+// How to use:
+//  Derive a class from this class, then override main().
+//
+class Pj_Thread : public Pj_Object
 {
 public:
@@ -17,132 +105,303 @@
     };
 
-    static PJ_Thread *create( PJ_Pool *pool, const char *thread_name,
-			      pj_thread_proc *proc, void *arg,
-			      pj_size_t stack_size, void *stack_ptr, 
-			      unsigned flags)
-    {
-	return (PJ_Thread*) pj_thread_create( pool->pool_(), thread_name, proc, arg, stack_size, stack_ptr, flags);
-    }
-
-    static PJ_Thread *register_current_thread(const char *name, pj_thread_desc desc)
-    {
-	return (PJ_Thread*) pj_thread_register(name, desc);
-    }
-
-    static PJ_Thread *get_current_thread()
-    {
-	return (PJ_Thread*) pj_thread_this();
-    }
-
-    static pj_status_t sleep(unsigned msec)
-    {
-	return pj_thread_sleep(msec);
-    }
-
-    static pj_status_t usleep(unsigned usec)
-    {
-	return pj_thread_usleep(usec);
-    }
-
+    //
+    // Default constructor.
+    //
+    Pj_Thread()
+        : thread_(NULL)
+    {
+    }
+
+    //
+    // Destroy thread.
+    //
+    ~Pj_Thread()
+    {
+        destroy();
+    }
+
+    //
+    // This is the main thread function.
+    //
+    virtual int main() = 0;
+
+    //
+    // Start a thread.
+    //
+    pj_status_t create( Pj_Pool *pool, 
+                        unsigned flags = 0,
+                        const char *thread_name = NULL,
+			pj_size_t stack_size = PJ_THREAD_DEFAULT_STACK_SIZE)
+    {
+        destroy();
+        return Pj_Thread_API::create( pool, &thread_, &thread_proc, this,
+                                      flags, thread_name);
+    }
+
+    //
+    // Get pjlib compatible thread object.
+    //
     pj_thread_t *pj_thread_t_()
     {
-	return (pj_thread_t*)this;
-    }
-
+	return thread_;
+    }
+
+    //
+    // Get thread name.
+    //
     const char *get_name()
     {
-	return pj_thread_get_name( this->pj_thread_t_() );
-    }
-
+        return Pj_Thread_API::get_name(thread_);
+    }
+
+    //
+    // Resume a suspended thread.
+    //
     pj_status_t resume()
     {
-	return pj_thread_resume( this->pj_thread_t_() );
-    }
-
+        return Pj_Thread_API::resume(thread_);
+    }
+
+    //
+    // Join this thread.
+    //
     pj_status_t join()
     {
-	return pj_thread_join( this->pj_thread_t_() );
-    }
-
+        return Pj_Thread_API::join(thread_);
+    }
+
+    //
+    // Destroy thread.
+    //
     pj_status_t destroy()
     {
-	return pj_thread_destroy( this->pj_thread_t_() );
-    }
-};
-
-
-class PJ_Thread_Local
-{
-public:
-    static PJ_Thread_Local *alloc()
-    {
-	long index = pj_thread_local_alloc();
-	return index < 0 ? NULL : (PJ_Thread_Local*)index;
-    }
-    void free()
-    {
-	pj_thread_local_free( this->tls_() );
-    }
-
-    long tls_() const
-    {
-	return (long)this;
-    }
-
-    void set(void *value)
-    {
-	pj_thread_local_set( this->tls_(), value );
-    }
-
-    void *get()
-    {
-	return pj_thread_local_get( this->tls_() );
-    }
-};
-
-
-class PJ_Atomic
-{
-public:
-    static PJ_Atomic *create(PJ_Pool *pool, long initial)
-    {
-	return (PJ_Atomic*) pj_atomic_create(pool->pool_(), initial);
-    }
-
+        if (thread_) {
+            Pj_Thread_API::destroy(thread_);
+            thread_ = NULL;
+        }
+    }
+
+protected:
+    pj_thread_t *thread_;
+
+    static int PJ_THREAD_FUNC thread_proc(void *obj)
+    {
+        Pj_Thread *thread_class = (Pj_Thread*)obj;
+        return thread_class->main();
+    }
+};
+
+
+//
+// External Thread
+//  (threads that were started by external means, i.e. not 
+//   with Pj_Thread::create).
+//
+// This class will normally be defined as local variable in
+// external thread's stack, normally inside thread's main proc.
+// But be aware that the handle will be destroyed on destructor!
+//
+class Pj_External_Thread : public Pj_Thread
+{
+public:
+    Pj_External_Thread()
+    {
+    }
+
+    //
+    // Register external thread so that pjlib functions can work
+    // in that thread.
+    //
+    pj_status_t register_this_thread( const char *name=NULL )
+    {
+        return Pj_Thread_API::register_this_thread(desc_, &thread_,name);
+    }
+
+private:
+    pj_thread_desc desc_;
+};
+
+
+//
+// Thread specific data/thread local storage/TLS.
+//
+class Pj_Thread_Local_API
+{
+public:
+    //
+    // Allocate thread local storage (TLS) index.
+    //
+    static pj_status_t alloc(long *index)
+    {
+        return pj_thread_local_alloc(index);
+    }
+
+    //
+    // Free TLS index.
+    //
+    static void free(long index)
+    {
+        pj_thread_local_free(index);
+    }
+
+    //
+    // Set thread specific data.
+    //
+    static pj_status_t set(long index, void *value)
+    {
+        return pj_thread_local_set(index, value);
+    }
+
+    //
+    // Get thread specific data.
+    //
+    static void *get(long index)
+    {
+        return pj_thread_local_get(index);
+    }
+
+};
+
+//
+// Atomic variable
+//
+// How to use:
+//   Pj_Atomic_Var var(pool, 0);
+//   var.set(..);
+//
+class Pj_Atomic_Var : public Pj_Object
+{
+public:
+    //
+    // Default constructor, initialize variable with NULL.
+    //
+    Pj_Atomic_Var()
+        : var_(NULL)
+    {
+    }
+
+    //
+    // Construct atomic variable.
+    //
+    Pj_Atomic_Var(Pj_Pool *pool, pj_atomic_value_t value)
+        : var_(NULL)
+    {
+        create(pool, value);
+    }
+
+    //
+    // Destructor.
+    //
+    ~Pj_Atomic_Var()
+    {
+        destroy();
+    }
+
+    //
+    // Create atomic variable.
+    //
+    pj_status_t create( Pj_Pool *pool, pj_atomic_value_t value)
+    {
+        destroy();
+	return pj_atomic_create(pool->pool_(), value, &var_);
+    }
+
+    //
+    // Destroy.
+    //
+    void destroy()
+    {
+        if (var_) {
+            pj_atomic_destroy(var_);
+            var_ = NULL;
+        }
+    }
+
+    //
+    // Get pjlib compatible atomic variable.
+    //
     pj_atomic_t *pj_atomic_t_()
     {
-	return (pj_atomic_t*)this;
-    }
-
-    pj_status_t destroy()
-    {
-	return pj_atomic_destroy( this->pj_atomic_t_() );
-    }
-
-    long set(long val)
-    {
-	return pj_atomic_set( this->pj_atomic_t_(), val);
-    }
-
-    long get()
-    {
-	return pj_atomic_get( this->pj_atomic_t_() );
-    }
-
-    long inc()
-    {
-	return pj_atomic_inc( this->pj_atomic_t_() );
-    }
-
-    long dec()
-    {
-	return pj_atomic_dec( this->pj_atomic_t_() );
-    }
-};
-
-
-class PJ_Mutex
-{
-public:
+	return var_;
+    }
+
+    //
+    // Set the value.
+    //
+    void set(pj_atomic_value_t val)
+    {
+	pj_atomic_set(var_, val);
+    }
+
+    //
+    // Get the value.
+    //
+    pj_atomic_value_t get()
+    {
+	return pj_atomic_get(var_);
+    }
+
+    //
+    // Increment.
+    //
+    void inc()
+    {
+	pj_atomic_inc(var_);
+    }
+
+    //
+    // Increment and get the result.
+    //
+    pj_atomic_value_t inc_and_get()
+    {
+        return pj_atomic_inc_and_get(var_);
+    }
+
+    //
+    // Decrement.
+    //
+    void dec()
+    {
+	pj_atomic_dec(var_);
+    }
+
+    //
+    // Decrement and get the result.
+    //
+    pj_atomic_value_t dec_and_get()
+    {
+        return pj_atomic_dec_and_get(var_);
+    }
+
+    //
+    // Add the variable.
+    //
+    void add(pj_atomic_value_t value)
+    {
+        pj_atomic_add(var_, value);
+    }
+
+    //
+    // Add the variable and get the value.
+    //
+    pj_atomic_value_t add_and_get(pj_atomic_value_t value)
+    {
+        return pj_atomic_add_and_get(var_, value );
+    }
+
+private:
+    pj_atomic_t *var_;
+};
+
+
+//
+// Mutex
+//
+class Pj_Mutex : public Pj_Object
+{
+public:
+    //
+    // Mutex type.
+    //
     enum Type
     {
@@ -152,51 +411,143 @@
     };
 
-    static PJ_Mutex *create( PJ_Pool *pool, const char *name, Type type)
-    {
-	return (PJ_Mutex*) pj_mutex_create( pool->pool_(), name, type);
-    }
-
-    pj_mutex_t *pj_mutex_()
-    {
-	return (pj_mutex_t*)this;
-    }
-
-    pj_status_t destroy()
-    {
-	return pj_mutex_destroy( this->pj_mutex_() );
-    }
-
-    pj_status_t lock()
-    {
-	return pj_mutex_lock( this->pj_mutex_() );
-    }
-
-    pj_status_t unlock()
-    {
-	return pj_mutex_unlock( this->pj_mutex_() );
-    }
-
-    pj_status_t trylock()
-    {
-	return pj_mutex_trylock( this->pj_mutex_() );
-    }
-
-#if PJ_DEBUG
-    pj_status_t is_locked()
-    {
-	return pj_mutex_is_locked( this->pj_mutex_() );
-    }
-#endif
-};
-
-
-class PJ_Semaphore
-{
-public:
-    static PJ_Semaphore *create( PJ_Pool *pool, const char *name, unsigned initial, unsigned max)
-    {
-	return (PJ_Semaphore*) pj_sem_create( pool->pool_(), name, initial, max);
-    }
-
+    //
+    // Default constructor will create default mutex.
+    //
+    explicit Pj_Mutex(Pj_Pool *pool, Type type = DEFAULT,
+                      const char *name = NULL)
+        : mutex_(NULL)
+    {
+        create(pool, type, name);
+    }
+
+    //
+    // Destructor.
+    //
+    ~Pj_Mutex()
+    {
+        destroy();
+    }
+
+    //
+    // Create mutex.
+    //
+    pj_status_t create( Pj_Pool *pool, Type type, const char *name = NULL)
+    {
+        destroy();
+	return pj_mutex_create( pool->pool_(), name, type,
+                                &mutex_ );
+    }
+
+    //
+    // Create simple mutex.
+    //
+    pj_status_t create_simple( Pj_Pool *pool,const char *name = NULL)
+    {
+        return create(pool, SIMPLE, name);
+    }
+
+    //
+    // Create recursive mutex.
+    //
+    pj_status_t create_recursive( Pj_Pool *pool, const char *name = NULL )
+    {
+        return create(pool, RECURSE, name);
+    }
+
+    //
+    // Get pjlib compatible mutex object.
+    //
+    pj_mutex_t *pj_mutex_t_()
+    {
+	return mutex_;
+    }
+
+    //
+    // Destroy mutex.
+    //
+    void destroy()
+    {
+        if (mutex_) {
+	    pj_mutex_destroy(mutex_);
+            mutex_ = NULL;
+        }
+    }
+
+    //
+    // Lock mutex.
+    //
+    pj_status_t acquire()
+    {
+	return pj_mutex_lock(mutex_);
+    }
+
+    //
+    // Unlock mutex.
+    //
+    pj_status_t release()
+    {
+	return pj_mutex_unlock(mutex_);
+    }
+
+    //
+    // Try locking the mutex.
+    //
+    pj_status_t tryacquire()
+    {
+	return pj_mutex_trylock(mutex_);
+    }
+
+private:
+    pj_mutex_t *mutex_;
+};
+
+
+//
+// Semaphore
+//
+class Pj_Semaphore : public Pj_Object
+{
+public:
+    //
+    // Construct semaphore
+    //
+    Pj_Semaphore(Pj_Pool *pool, unsigned max,
+                 unsigned initial = 0, const char *name = NULL)
+    : sem_(NULL)
+    {
+    }
+
+    //
+    // Destructor.
+    //
+    ~Pj_Semaphore()
+    {
+        destroy();
+    }
+
+    //
+    // Create semaphore
+    //
+    pj_status_t create( Pj_Pool *pool, unsigned max,
+                        unsigned initial = 0, const char *name = NULL )
+    {
+        destroy();
+	return pj_sem_create( pool->pool_(), name, initial, max, &sem_);
+    }
+
+    //
+    // Destroy semaphore.
+    //
+    void destroy()
+    {
+        if (sem_) {
+            pj_sem_destroy(sem_);
+            sem_ = NULL;
+        }
+    }
+
+    //
+    // Get pjlib compatible semaphore object.
+    //
     pj_sem_t *pj_sem_t_()
     {
@@ -204,9 +555,7 @@
     }
 
-    pj_status_t destroy()
-    {
-	return pj_sem_destroy(this->pj_sem_t_());
-    }
-
+    //
+    // Wait semaphore.
+    //
     pj_status_t wait()
     {
@@ -214,9 +563,15 @@
     }
 
-    pj_status_t lock()
+    //
+    // Wait semaphore.
+    //
+    pj_status_t acquire()
     {
 	return wait();
     }
 
+    //
+    // Try wait semaphore.
+    //
     pj_status_t trywait()
     {
@@ -224,9 +579,15 @@
     }
 
-    pj_status_t trylock()
+    //
+    // Try wait semaphore.
+    //
+    pj_status_t tryacquire()
     {
 	return trywait();
     }
 
+    //
+    // Post semaphore.
+    //
     pj_status_t post()
     {
@@ -234,39 +595,90 @@
     }
 
-    pj_status_t unlock()
+    //
+    // Post semaphore.
+    //
+    pj_status_t release()
     {
 	return post();
     }
-};
-
-
-class PJ_Event
-{
-public:
-    static PJ_Event *create( PJ_Pool *pool, const char *name, bool manual_reset, bool initial)
-    {
-	return (PJ_Event*) pj_event_create(pool->pool_(), name, manual_reset, initial);
-    }
-
+
+private:
+    pj_sem_t *sem_;
+};
+
+
+//
+// Event object.
+//
+class Pj_Event
+{
+public:
+    //
+    // Construct event object.
+    //
+    Pj_Event( Pj_Pool *pool, bool manual_reset = false,
+              bool initial = false, const char *name = NULL )
+    : event_(NULL)
+    {
+        create(pool, manual_reset, initial, name);
+    }
+
+    //
+    // Destructor.
+    //
+    ~Pj_Event()
+    {
+        destroy();
+    }
+
+    //
+    // Create event object.
+    //
+    pj_status_t create( Pj_Pool *pool, bool manual_reset = false, 
+                        bool initial = false, const char *name = NULL)
+    {
+        destroy();
+	return pj_event_create(pool->pool_(), name, manual_reset, initial,
+                               &event_);
+    }
+
+    //
+    // Get pjlib compatible event object.
+    //
     pj_event_t *pj_event_t_()
     {
-	return (pj_event_t*)this;
-    }
-
-    pj_status_t destroy()
-    {
-	return pj_event_destroy(this->pj_event_t_());
-    }
-
+	return event_;
+    }
+
+    //
+    // Destroy event object.
+    //
+    void destroy()
+    {
+        if (event_) {
+	    pj_event_destroy(event_);
+            event_ = NULL;
+        }
+    }
+
+    //
+    // Wait.
+    //
     pj_status_t wait()
     {
-	return pj_event_wait(this->pj_event_t_());
-    }
-
+	return pj_event_wait(event_);
+    }
+
+    //
+    // Try wait.
+    //
     pj_status_t trywait()
     {
-	return pj_event_trywait(this->pj_event_t_());
-    }
-
+	return pj_event_trywait(event_);
+    }
+
+    //
+    // Set event state to signalled.
+    //
     pj_status_t set()
     {
@@ -274,4 +686,7 @@
     }
 
+    //
+    // Release one waiting thread.
+    //
     pj_status_t pulse()
     {
@@ -279,34 +694,60 @@
     }
 
+    //
+    // Set a non-signalled.
+    //
     pj_status_t reset()
     {
 	return pj_event_reset(this->pj_event_t_());
     }
-};
-
-class PJ_OS
-{
-public:
-    static pj_status_t gettimeofday( PJ_Time_Val *tv )
+
+private:
+    pj_event_t *event_;
+};
+
+//
+// OS abstraction.
+//
+class Pj_OS_API
+{
+public:
+    //
+    // Get current time.
+    //
+    static pj_status_t gettimeofday( Pj_Time_Val *tv )
     {
 	return pj_gettimeofday(tv);
     }
 
-    static pj_status_t time_decode( const PJ_Time_Val *tv, pj_parsed_time *pt )
+    //
+    // Parse to time of day.
+    //
+    static pj_status_t time_decode( const Pj_Time_Val *tv, 
+                                    pj_parsed_time *pt )
     {
 	return pj_time_decode(tv, pt);
     }
 
-    static pj_status_t time_encode(const pj_parsed_time *pt, PJ_Time_Val *tv)
+    //
+    // Parse from time of day.
+    //
+    static pj_status_t time_encode( const pj_parsed_time *pt, 
+                                    Pj_Time_Val *tv)
     {
 	return pj_time_encode(pt, tv);
     }
 
-    static pj_status_t time_local_to_gmt( PJ_Time_Val *tv )
+    //
+    // Convert to GMT.
+    //
+    static pj_status_t time_local_to_gmt( Pj_Time_Val *tv )
     {
 	return pj_time_local_to_gmt( tv );
     }
 
-    static pj_status_t time_gmt_to_local( PJ_Time_Val *tv) 
+    //
+    // Convert time to local.
+    //
+    static pj_status_t time_gmt_to_local( Pj_Time_Val *tv) 
     {
 	return pj_time_gmt_to_local( tv );
@@ -314,30 +755,32 @@
 };
 
-
-inline pj_status_t PJ_Time_Val::gettimeofday()
-{
-    return PJ_OS::gettimeofday(this);
+//
+// Timeval inlines.
+//
+inline pj_status_t Pj_Time_Val::gettimeofday()
+{
+    return Pj_OS_API::gettimeofday(this);
 }
 
-inline pj_parsed_time PJ_Time_Val::decode()
+inline pj_parsed_time Pj_Time_Val::decode()
 {
     pj_parsed_time pt;
-    PJ_OS::time_decode(this, &pt);
+    Pj_OS_API::time_decode(this, &pt);
     return pt;
 }
 
-inline pj_status_t PJ_Time_Val::encode(const pj_parsed_time *pt)
-{
-    return PJ_OS::time_encode(pt, this);
+inline pj_status_t Pj_Time_Val::encode(const pj_parsed_time *pt)
+{
+    return Pj_OS_API::time_encode(pt, this);
 }
 
-inline pj_status_t PJ_Time_Val::to_gmt()
-{
-    return PJ_OS::time_local_to_gmt(this);
+inline pj_status_t Pj_Time_Val::to_gmt()
+{
+    return Pj_OS_API::time_local_to_gmt(this);
 }
 
-inline pj_status_t PJ_Time_Val::to_local()
-{
-    return PJ_OS::time_gmt_to_local(this);
+inline pj_status_t Pj_Time_Val::to_local()
+{
+    return Pj_OS_API::time_gmt_to_local(this);
 }
 
Index: pjproject/main/pjlib/include/pj++/pool.hpp
===================================================================
--- pjproject/main/pjlib/include/pj++/pool.hpp	(revision 35)
+++ pjproject/main/pjlib/include/pj++/pool.hpp	(revision 36)
@@ -1,4 +1,3 @@
 /* $Id$
- *
  */
 #ifndef __PJPP_POOL_H__
@@ -7,75 +6,206 @@
 #include <pj/pool.h>
 
-class PJ_Pool
+class Pj_Pool;
+class Pj_Caching_Pool;
+
+//
+// Base class for all Pjlib objects
+//
+class Pj_Object
 {
 public:
+    void *operator new(unsigned int class_size, Pj_Pool *pool);
+    void operator delete(void*);
+    void operator delete(void*, Pj_Pool*);
+
+    //
+    // Inline implementations at the end of this file.
+    //
+
+private:
+    // Can not use normal new operator; must use pool.
+    // e.g.:
+    //   obj = new(pool) Pj_The_Object(pool, ...);
+    //
+    void *operator new(unsigned int)
+    {}
+};
+
+
+//
+// Pool.
+//
+class Pj_Pool : public Pj_Object
+{
+public:
+    //
+    // Default constructor, initializes internal pool to NULL.
+    // Application must call attach() some time later.
+    //
+    Pj_Pool()
+        : p_(NULL)
+    {
+    }
+
+    //
+    // Create pool.
+    //
+    Pj_Pool(Pj_Caching_Pool &caching_pool,
+            pj_size_t initial_size, 
+            pj_size_t increment_size, 
+            const char *name = NULL, 
+            pj_pool_callback *callback = NULL);
+
+    //
+    // Construct from existing pool.
+    //
+    explicit Pj_Pool(pj_pool_t *pool)
+        : p_(pool)
+    {
+    }
+
+    //
+    // Attach existing pool.
+    //
+    void attach(pj_pool_t *pool)
+    {
+        p_ = pool;
+    }
+
+    //
+    // Destructor.
+    //
+    // Release pool back to factory. Remember: if you delete pool, then 
+    // make sure that all objects that have been allocated from this pool
+    // have been properly destroyed.
+    //
+    // This is where C++ is trickier than plain C!!
+    //
+    ~Pj_Pool()
+    {
+        if (p_)
+	    pj_pool_release(p_);
+    }
+
+    //
+    // Get name.
+    //
     const char *getobjname() const
     {
-	return pj_pool_getobjname(this->pool_());
-    }
-
+	return pj_pool_getobjname(p_);
+    }
+
+    //
+    // Get pjlib compatible pool object.
+    //
     pj_pool_t *pool_()
     {
-	return (pj_pool_t*)this;
-    }
-
+	return p_;
+    }
+
+    //
+    // Get pjlib compatible pool object.
+    //
     const pj_pool_t *pool_() const
     {
-	return (const pj_pool_t*)this;
-    }
-
-    void release()
-    {
-	pj_pool_release(this->pool_());
-    }
-
+	return p_;
+    }
+
+    //
+    // Get pjlib compatible pool object.
+    //
+    pj_pool_t *pj_pool_t_()
+    {
+	return p_;
+    }
+
+    //
+    // Reset pool.
+    //
     void reset()
     {
-	pj_pool_reset(this->pool_());
-    }
-
+	pj_pool_reset(p_);
+    }
+
+    //
+    // Get current capacity.
+    //
     pj_size_t get_capacity()
     {
-	pj_pool_get_capacity(this->pool_());
-    }
-
+	pj_pool_get_capacity(p_);
+    }
+
+    //
+    // Get current total bytes allocated from the pool.
+    //
     pj_size_t get_used_size()
     {
-	pj_pool_get_used_size(this->pool_());
-    }
-
+	pj_pool_get_used_size(p_);
+    }
+
+    //
+    // Allocate.
+    //
     void *alloc(pj_size_t size)
     {
-	return pj_pool_alloc(this->pool_(), size);
-    }
-
+	return pj_pool_alloc(p_, size);
+    }
+
+    //
+    // Allocate elements and zero fill the memory.
+    //
     void *calloc(pj_size_t count, pj_size_t elem)
     {
-	return pj_pool_calloc(this->pool_(), count, elem);
-    }
+	return pj_pool_calloc(p_, count, elem);
+    }
+
+    //
+    // Allocate and zero fill memory.
+    //
+    void *zalloc(pj_size_t size)
+    {
+        return pj_pool_zalloc(p_, size);
+    }
+
+private:
+    pj_pool_t *p_;
 };
 
-class PJ_Caching_Pool
+
+//
+// Caching pool.
+//
+class Pj_Caching_Pool
 {
 public:
-    void init(pj_size_t max_capacity,
-	      const pj_pool_factory_policy *pol=&pj_pool_factory_default_policy)
-    {
-	pj_caching_pool_init(&cp_, pol, max_capacity);
-    }
-
-    void destroy()
+    //
+    // Construct caching pool.
+    //
+    Pj_Caching_Pool( pj_size_t cache_capacity = 0,
+	             const pj_pool_factory_policy *pol=&pj_pool_factory_default_policy)
+    {
+	pj_caching_pool_init(&cp_, pol, cache_capacity);
+    }
+
+    //
+    // Destroy caching pool.
+    //
+    ~Pj_Caching_Pool()
     {
 	pj_caching_pool_destroy(&cp_);
     }
 
-    PJ_Pool *create_pool(const char *name, pj_size_t initial_size, pj_size_t increment_size, pj_pool_callback *callback)
-    {
-	return (PJ_Pool*) (*cp_.factory.create_pool)(&cp_.factory, name, initial_size, increment_size, callback);
-    }
-
-    void release_pool( PJ_Pool *pool )
-    {
-	pj_pool_release(pool->pool_());
+    //
+    // Create pool.
+    //
+    pj_pool_t *create_pool( pj_size_t initial_size, 
+                            pj_size_t increment_size, 
+                            const char *name = NULL, 
+                            pj_pool_callback *callback = NULL)
+    {
+	return (pj_pool_t*)(*cp_.factory.create_pool)(&cp_.factory, name, 
+                                                     initial_size, 
+                                                     increment_size, 
+                                                     callback);
     }
 
@@ -84,3 +214,31 @@
 };
 
+//
+// Inlines for Pj_Object
+//
+inline void *Pj_Object::operator new(unsigned int class_size, Pj_Pool *pool)
+{
+    return pool->alloc(class_size);
+}
+inline void Pj_Object::operator delete(void *ptr)
+{
+}
+inline void Pj_Object::operator delete(void *ptr, Pj_Pool*)
+{
+}
+
+//
+// Inlines for Pj_Pool
+//
+inline Pj_Pool::Pj_Pool( Pj_Caching_Pool &caching_pool,
+                         pj_size_t initial_size, 
+                         pj_size_t increment_size, 
+                         const char *name, 
+                         pj_pool_callback *callback)
+{
+    p_ = caching_pool.create_pool(initial_size, increment_size, name,
+                                  callback);
+}
+
+
 #endif	/* __PJPP_POOL_H__ */
